<template>
<div>

    <button style="margin-left:20%;" type="button" class="btn btn-primary" data-toggle="modal" data-target="#modalproveedores">+ Agregar Proveedores</button>

 


<!-- Modal: AGREGAR CATEGORIAS -->
<div class="modal fade" id="modalproveedores" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
  aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <!--Header-->
      <div class="modal-header">
        <h4 class="modal-title" id="myModalLabel">Proveedores</h4>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">×</span>
        </button>
      </div>
      <!--Body-->
        <div class="modal-body">

          <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Registro Proveedores</div>

                <div class="card-body">

                    <form v-on:submit.prevent="create" method="POST">
                       


                        <div class="form-group row">
                               
                            <label for="nombre" class="col-md-4 col-form-label text-md-right">Nombre</label>

                            <div class="col-md-6">
                                <input v-model="proveedor.nombre" id="nombre" type="text" name="nombre"  required autocomplete="nombre" autofocus >                
                            </div>
                        </div>

                          <div class="form-group row">
                            <label for="apellido" class="col-md-4 col-form-label text-md-right">Apellido</label>

                            <div class="col-md-6">
                                <input v-model="proveedor.apellido" id="apellido" type="text" name="apellido"  required autocomplete="apellido" autofocus>                
                            </div>
                        </div>  
                            <div class="form-group row">
                            <label for="direccion" class="col-md-4 col-form-label text-md-right">Direccion</label>

                            <div class="col-md-6">
                                <input v-model="proveedor.direccion" id="direccion" type="text" name="direccion" required autocomplete="direccion" >
                            </div>
                        </div>


                        <div class="form-group row">
                            <label for="rut" class="col-md-4 col-form-label text-md-right">Rut</label>

                            <div class="col-md-6">
                                <input v-model="proveedor.rut"  id="rut" type="rut" name="rut" required autocomplete="rut" placeholder="11.111.111-1">
                            <span v-if="errors.rut">{{errors.rut[0]}}</span>
                            </div>
                            
                        </div>

                        <div class="form-group row">
                            <label for="telefono" class="col-md-4 col-form-label text-md-right">Telefono</label>

                            <div class="col-md-6">
                                <input v-model="proveedor.telefono" id="telefono" type="number" name="telefono" required autocomplete="telefono">
                            </div>
                        </div>
                            <div class="form-group row">
                            <label for="email" class="col-md-4 col-form-label text-md-right">Email</label>

                            <div class="col-md-6">
                                <input v-model="proveedor.email" id="email" type="text" name="email" required autocomplete="email" >
                            </div>
                        </div>

                       <button  type="submit"  class="btn btn-primary">Agregar</button>
                    </form>
                </div>
            </div>
        </div>
    </div>

         </div>

    </div>
  </div>
</div>

		 <form id="form" class="form-inline my-2 my-lg-0">
                <input v-model="Search"  style="width:55%;" id="control" class="form-control mr-sm-2" type="text" placeholder="Search">
                <button class="btn btn-outline-success my-2 my-sm-0" type=""><i class="fa fa-search" aria-hidden="true"></i></button>
            </form>

<table>
				<thead>
					<tr>
						<th>Nombre</th>
            <th>Apellido</th>
						<th>RUT</th>
						<th>DIRECCION</th>
            <th>TELEFONO</th>
            <th>EMAIL</th>
            <th>ELIMINAR</th>
					</tr>
				</thead>
				<tbody v-for="proveedor in searchproveedores" :key="proveedor.id">
					<tr>
						<td >{{proveedor.nombre}}</td>
              <td >{{proveedor.apellido}}</td>
						<td >{{proveedor.rut}}</td>
            <td >{{proveedor.direccion}}</td>
             <td >{{proveedor.telefono}}</td>
              <td >{{proveedor.email}}</td>
						<td><button type="button" class="btn btn-danger" @click="remove(proveedor)">Eliminar</button></td>

					</tr>
				</tbody>
			</table>



</div>
</template>

<script>
    export default {	

    	
		data() {
			return {
				csrf: document.head.querySelector('meta[name="csrf-token"]').getAttribute('content'),

				proveedor:{
					nombre:"",
          apellido:"",
          direccion:"",
          rut:"",
          telefono:"",
          email:""
				},
         Search:'',
         errors:{},
       
			}
		},
    props:["proveedores"],
		mounted(){
			this.fetchdata();
		},
	      computed:{
     searchproveedores(){
     if(this.Search){
      let resultados = this.$parent.proveedores.filter(c => 
        c.nombre.toLowerCase().startsWith(this.Search));
       
      resultados =[
        ...resultados,
        ...this.$parent.proveedores.filter(c => c.apellido.toLowerCase().startsWith(this.Search)),
        ...this.$parent.proveedores.filter(c => c.email.toLowerCase().startsWith(this.Search)),
        ...this.$parent.proveedores.filter(c => c.rut.includes(this.Search)),
      ];
      return [...new Set(resultados)];
     }else{
        return this.$parent.proveedores;
      }
    }
  },

		methods:{
			fetchdata(){
				const self = this;
				axios.get('api/proveedores').then(function(response){
					self.$parent.proveedores = response.data.map(function (prov) {
            return prov;

          });
					
				})
			},

			
		
			create(){
        this.errors=[]
				axios.post("api/rproveedores",this.proveedor).then(response=>{
					this.$parent.proveedores.push(response.data.proveedores);
					this.proveedor.nombre=""
          this.proveedor.apellido=""
          this.proveedor.direccion=""
					this.proveedor.rut=""
          this.proveedor.telefono=""
          this.proveedor.email=""
				}).catch(error=>{
            if(error.response.status==422){
              this.errors=error.response.data.errors

            }
            //else if(error.response.)

        })
			},
       
			remove(proveedor) {
                if (confirm("Esta seguro que desea eliminarlo?")) {
                    axios.delete('api/deleteprov/' + proveedor.id)
                }
                this.fetchdata();
               console.log(this.errors)
            },

	       value: function (val) {
            if (this.rut) {
                this.value = this.formatRut(val)
                let len = this.value.length - 1;
                if (len > 3) {
                    let dv = this.value[len];
                    let beforeDv = this.value.substring(0, len).replace(/\B(?=(\d{3})+(?!\d))/g, '.');
                    this.value = beforeDv + '-' + dv;
                }
            }
        },
          formatRut(value) {
            return value.replace(/^0+|[^0-9kK]+/g, '').toUpperCase();
        }
	}

}

</script>

<style scoped>

body {
  margin: 0;
  background: linear-gradient(45deg, #49a09d, #5f2c82);
  font-family: sans-serif;
  font-weight: 100;
}

.container {
  position: absolute;
  top: 5%;
  left: 5%;
  transform: translate(-50%, -50%);
}

table {
  margin-left:5%;
  margin-top:2%;
  border-collapse: collapse;
  overflow: hidden;
  box-shadow: 0 0 20px rgba(0,0,0,0.1);
   border-top:2px solid #ccc;
  border-left: 2px solid #ccc;
  margin-bottom:1em;
}

th,
td {
  padding:20px;
  background-color: rgba(255,255,255,0.2);
  color: #000000;
  padding: 0.5em -1em;
    border-bottom: 1px solid #ccc;
    border-right: 1px solid #ccc;

}

th {
    padding: 0.5em 1em;
    border-bottom: 1px solid #ccc;
    border-right: 1px solid #ccc;
    white-space: pre;
   background-color: rgba(255,255,255,0.2);
  color: #000000;
}

thead {
  th {
    background-color: rgba(255,255,255,0.2);
  color: #000000;
  }
}

tbody {
  tr {
    &:hover {
      background-color: rgba(255,255,255,0.3);
    }
  }
  td {
    position: relative;
    &:hover {
      &:before {
        content: "";
        position: absolute;
        left: 0;
        right: 0;
        top: -9999px;
        bottom: -9999px;
        background-color: rgba(255,255,255,0.2);
        z-index: -1;
      }
    }
  }
}


</style>